#include "ti83p.h" 

.org $4000

; change this to your ID
#define DEVELOPER_ID    $01,$23,$45

EXT_APP equ 1   ;This definition is required of all apps
cseg            ;This linker directive is required of all apps.

;This is the application header definition area required for all apps.
.db 080h,0Fh    ;Field: Program length
.db   00h,00h,00h,00h ;Length=0 (N/A for unsigned apps)
.db 080h,012h    ;Field: Program type
.db   01h,04h  ;Type= Shareware, TI-83Plus
.db 080h,021h    ;Field: App ID
.db   01h       ;Id = 1
.db 080h,031h    ;Field: App Build
.db   01h       ;Build = 1
.db 080h,048h    ;Field: App Name
.db "Cartman",020h ;Name = "Hello   " must be 8 characters
.db 080h,081h    ;Field: App Pages
.db 01h         ;App Pages = 1
.db 080h,090h    ;No default splash screen
.db 03h,026h ,09h,04h, 04h,06fh,01bh,80h     ;Field: Date stamp- 5/12/1999
.db 02h,0dh,040h                             ;Dummy encrypted TI date stamp signature
.db 0a1h ,06bh ,099h ,0f6h ,059h ,0bch ,067h 
.db 0f5h ,085h ,09ch ,09h ,06ch ,0fh ,0b4h ,03h ,09bh ,0c9h 
.db 03h ,032h ,02ch ,0e0h ,03h ,020h ,0e3h ,02ch ,0f4h ,02dh 
.db 073h ,0b4h ,027h ,0c4h ,0a0h ,072h ,054h ,0b9h ,0eah ,07ch 
.db 03bh ,0aah ,016h ,0f6h ,077h ,083h ,07ah ,0eeh ,01ah ,0d4h 
.db 042h ,04ch ,06bh ,08bh ,013h ,01fh ,0bbh ,093h ,08bh ,0fch 
.db 019h ,01ch ,03ch ,0ech ,04dh ,0e5h ,075h 
.db 80h,7Fh      ;Field: Program Image length
.db   0,0,0,0    ;Length=0, N/A
.db   0,0,0,0    ;Reserved
.db   0,0,0,0    ;Reserved
.db   0,0,0,0    ;Reserved
.db   0,0,0,0    ;Reserved
 
;End of header data

;  Main app control begins here
StartApp:
 ld hl,Layer1
 ld de,plotsscreen
 ld bc,768
 ldir
 bcall(_grbufcpy)
 
 ld hl,Sound
Start:
 di             ;disables interrupts
 ld e,(hl)          ;loads e with hl
 inc hl         ;increases hl
 ld d,(hl)          ;loads d with hl
 inc hl         ;increases hl
 ld b,128           ;stores b as 128
SLoop:
 ld c,19            ;stores c as 19
Loop:
 dec c          ;decreases c
 nop                ;nothing happens here (timing)
 nop                ;nothing happens here (timing)
 nop                ;nothing happens here (timing)
 jr nz,Loop         ;loops until c is 0
 rrc b          ;
 jr nc,Play         ;goes, if no carry, to Play
 inc hl         ;increases hl
 dec de         ;decreases de
 ld a,d         ;loads a with value from d
 or e               ;compares a with e using Boolean 'or'
 jr z,Done          ;if true, goes to Done
Play:
 ld a,(hl)          ;loads a with hl
 and b          ;compares with b using Boolean 'and'
 jr z,Play1         ;if true, go to Play1
 ld a,$0C0      ;load a with the 'Link_Off' value
 out (0),a  ;turn off the link port
 jr SLoop           ; go to SLoop
Play1:
 ld a,$0C3      ;load a with the 'Link_On' value
 out (0),a  ;turn on the link port
 jr SLoop           ; go to SLoop
Done:
 di                 ;disables interrupts
 bjump(4027h)

#include "cartman.asm"

.end
